{ 000401-2.PAS                                                              }
{ 2000-04-01 programmeerimisolmpiaadi 2. lesande lahendus                 }
{    JOONISE PGAMINE                                                       }
{ Ahto Truu                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

const
   fsis = 'JOONIS.SIS';                                  { sisendfaili nimi }
   fval = 'JOONIS.VAL';                                 { vljundfaili nimi }

type
   punkt = record
      x, y : real;
   end;

{ leiab sirgete (p1,p2) ja x=p3.x likepunkti }
procedure loika_x (p1, p2, p3 : punkt; var p : punkt);
begin
   p.x := p3.x;
   p.y := p1.y + (p3.x - p1.x) * (p2.y - p1.y) / (p2.x - p1.x);
end;

{ leiab sirgete (p1,p2) ja y=p3.y likepunkti }
procedure loika_y (p1, p2, p3 : punkt; var p : punkt);
begin
   p.x := p1.x + (p3.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y);
   p.y := p3.y;
end;

{ pgab antud ligu antud aknaga; tagastab true, kui midagi alles ka ji }
function puga_loik (a1, a2 : punkt; var l1, l2 : punkt) : boolean;
var p1, p2 : ^punkt;
begin
   puga_loik := true;

      { paneme p1 osutama vasaku ja p2 parema otspunkti peale }
   if l1.x < l2.x then begin
      p1 := @l1; p2 := @l2;
   end else begin
      p1 := @l2; p2 := @l1;
   end;
      { jtame alles sirgete x=a1.x ja x=a2.x  vahel oleva osa }
   if (p2^.x < a1.x) or (p1^.x > a2.x) then
      puga_loik := false
   else begin
      if p1^.x < a1.x then
         loika_x (p1^, p2^, a1, p1^);
      if a2.x < p2^.x then
         loika_x (p1^, p2^, a2, p2^);
   end;

      { paneme p1 osutama alumise ja p2 lemise otspunkti peale }
   if l1.y < l2.y then begin
      p1 := @l1; p2 := @l2;
   end else begin
      p1 := @l2; p2 := @l1;
   end;
      { jtame alles sirgete y=a1.y ja y=a2.y  vahel oleva osa }
   if (p2^.y < a1.y) or (p1^.y > a2.y) then
      puga_loik := false
   else begin
      if p1^.y < a1.y then
         loika_y (p1^, p2^, a1, p1^);
      if a2.y < p2^.y then
         loika_y (p1^, p2^, a2, p2^);
   end;
end;

var
   fs, fv : text;
   a1, a2 : punkt;                                            { akna nurgad }
   l1, l2 : punkt;                                       { ligu otspunktid }
   n, i : integer;

begin
   assign (fs, fsis); reset (fs);
   assign (fv, fval); rewrite (fv);
   readln (fs, a1.x, a1.y, a2.x, a2.y);
   readln (fs, n);
   for i := 1 to n do begin
      readln (fs, l1.x, l1.y, l2.x, l2.y);
      if puga_loik (a1, a2, l1, l2) then
         writeln (fv,
            l1.x :0:3, ' ', l1.y :0:3, ' ',
            l2.x :0:3, ' ', l2.y :0:3)
      else
         writeln (fv, 'OUT');
   end;
   close (fv);
   close (fs);
end.